#include "pdc2.h"



/***************************************************************/

/* When C tends to infinite */

SCALAR bc3()
{
  return (rg[1]*dr*dr*rhok[1][0]/epsilon + (rg[1]-0.5)*inner_dc);
}

void circuit3()
{
int i;
static SCALAR tmp1, tmp2, tmp3;
static int init_flag = 1;

  oldsigma = sigma;

  if (init_flag)
  {
   tmp1 = (rminn+0.5)*epsilon/(rminn*dr);
   tmp3 = 1.0/(dt); /*  ngt to compensate from 1d-2d */
   init_flag = 0;
	}

  tmp2 = (rminn+0.25)*dr*0.5/rminn;

  sigma = tmp1*(phik[0][0]-phik[1][0])-rhok[0][0]*tmp2;

  exti = area*((sigma-oldsigma)*tmp3 - jp); /* current = dsigma/dt - J */

}

/***************************************************************/
/* The general case */

SCALAR bc4()
{
  static SCALAR a0, a1, a2, a3, a4;
  SCALAR k;
  
  if(!a0)
    {
      a0= 2.25*extl/dt/dt +1.5*extr/dt +1/extc;
      a1= -6*extl/dt/dt -2*extr/dt;
      a2= 5.5*extl/dt/dt +.5*extr/dt;
      a3= -2*extl/dt/dt;
      a4= .25*extl/dt/dt;
    }
  k= (a1*extq +a2*extq_1 +a3*extq_2 +a4*extq_3)/a0;
  return (((rminn+0.25)*dr*rhok[0][0]*0.5 +rminn*(sigma +dt*jp) +
	   rminn*(inner_dc/a0 -k -extq)/area)*dr/((rminn+0.5)*epsilon));
}

void circuit4()
{
  static SCALAR a0, a1, a2, a3, a4;
  SCALAR k;
  
  if(!a0)
    {
      a0= 2.25*extl/dt/dt +1.5*extr/dt +1/extc;
      a1= -6*extl/dt/dt -2*extr/dt;
      a2= 5.5*extl/dt/dt +.5*extr/dt;
      a3= -2*extl/dt/dt;
      a4= .25*extl/dt/dt;
    }
  k= (a1*extq +a2*extq_1 +a3*extq_2 +a4*extq_3)/a0;
  extq_3= extq_2;
  extq_2= extq_1;
  extq_1= extq;
  extq= (inner_dc-phik[0][0])/a0 -k;
  
  exti= (extq -extq_1)/dt;
  oldsigma = sigma;
  sigma += jp*dt +(extq -extq_1)/area;
}

/***************************************************************/





